source('utility.R')

#============================== Setup for running on Gauss... ==============================#

args <- commandArgs(TRUE)

# This will print the command line argument e.g., a number from 1 to 100
cat("Command-line arguments:\n")
print(args)

####
# sim_start ==> Lowest dataset number to be analyzed by this particular batch job
###

###################
sim_start <- 0
###################

if (length(args)==0){
  sim_num <- sim_start + 1
  set.seed(161104)
  sinkit <- FALSE
} else {
  sim_num <- sim_start + as.numeric(args[1])
  set.seed(826*sim_num + 161104)
}

i <- sim_num
sinkfile <- paste("output_progress_",i,".txt",sep="")

cat(paste("\nAnalyzing dataset number ",i,"...\n\n",sep=""))

id = Sys.getenv('SLURM_ARRAY_TASK_ID')
id = as.numeric(id)
#============================================================================

n=200; p=1000
t=0
sd=0.8

# simulate the covariates
{set.seed(826)
X <- matrix(rep(0, n*p), nrow=n)
for (i in 1:n) {
  w=rtruncnorm(p, a=0, b=1)
  u=rtruncnorm(1, a=0, b=1); v=rtruncnorm(1, a=0, b=1)
  X[i, 1:4]=(w[1:4]+t*u)/(1+t)
  X[i, 5:p]=(w[5:p]+t*v)/(1+t)
}
}
rm(.Random.seed, envir=.GlobalEnv)
Ey <- f1(X[,1])+f2(X[,2])+f3(X[,3])+f4(X[,4])

# generate y
result <- sim_coverage(sd=sd, alpha=0.05, l=3, K=8)
filename = paste("results/sim_",as.character(id),'.rds',sep="")
saveRDS(result,file = filename)