files = list.files(pattern = ".rds")
n_file = length(files)
results = vector("list",n_file)
for(i in 1:n_file){
  results[[i]]=readRDS(files[[i]])
}
save(results, file="rkb.rda")

load('rkb.rda')

#var_ind = sapply(results, function(x) x[[5]])
#sum((var_ind))/n_file 
#l=3 92.6%
#l=4 93.59%
#sigma=0.8 93.5%
#sigma=1.2 75.3%
#k=8 81.1%
#f3: 90.3%
#f2: 91.3%
#f1: 92.9%

f_ind1 = sapply(results, function(x) x[[1]][1,])
f_coverage1 = apply(f_ind1, 1, mean)
f_ind2 = sapply(results, function(x) x[[1]][2,])
f_coverage2 = apply(f_ind2, 1, mean)
f_ind3 = sapply(results, function(x) x[[1]][3,])
f_coverage3 = apply(f_ind3, 1, mean)
f_ind4 = sapply(results, function(x) x[[1]][4,])
f_coverage4 = apply(f_ind4, 1, mean)

Ey_ind = sapply(results, function(x) x[[8]])
Ey_coverage = apply(Ey_ind, 1, mean) #avg: 93.19% sd: 0.0142

Ey0_ind = sapply(results, function(x) x[[10]])
Ey0_coverage = apply(Ey0_ind, 1, mean) #avg: 93.92% sd: 0.0118

Ey_width = sapply(results, function(x) x[[9]])
Ey_width_avg = apply(Ey_width, 1, mean) #avg: 1.6683 sd: 0.2640

Ey0_width = sapply(results, function(x) x[[11]])
Ey0_width_avg = apply(Ey0_width, 1, mean) #avg: 1.6481 sd: 0.2601

mean(Ey_coverage)
mean(Ey_width)
mean(Ey0_coverage)
mean(Ey0_width)
var_ind = sapply(results, function(x) x[[4]])
mean(var_ind) #0.9290
var_width = sapply(results, function(x) x[[5]])
mean(var_width) #0.4664

var0_ind = sapply(results, function(x) x[[6]])
mean(var0_ind) #0.9560
var0_width = sapply(results, function(x) x[[7]])
mean(var0_width) #0.4469

f2_prob = sapply(results, function(x) x[[13]])
f4_prob = sapply(results, function(x) x[[15]])

n=250;p=1500;t=0
{set.seed(826)
  X <- matrix(rep(0, n*p), nrow=n)
  for (i in 1:n) {
    w=rtruncnorm(p, a=0, b=1)
    u=rtruncnorm(1, a=0, b=1); v=rtruncnorm(1, a=0, b=1)
    X[i, 1:4]=(w[1:4]+t*u)/(1+t)
    X[i, 5:p]=(w[5:p]+t*v)/(1+t)
  }
}

K=6; l=4
m_n <- K+l
bs_X <- matrix( rep(0, n*m_n*p), nrow=n)
for (i in 1:p) {
  bs_X[,(m_n*i-m_n+1):(m_n*i)] <- bs(X[,i], df = m_n, degree = l)
}
bs_X <- scale(bs_X, scale=F)

alpha=0.05
par(mfrow = c(2,2), mar=c(2, 3.5, 2, 1) + 0.1)
X1 = sort(X[,1])
plot(X1, f_coverage1, ylim=c(0, 1), type="l", lty=1, xlab="x", ylab="coverage",mgp=c(1.8,0.6,0), main="f1")
f = f1(X1)
f = (f - min(f))/diff(range(f))
lines(X1, f, lty=2)
abline(h=1-alpha, lty=3, col="red")

X2 = sort(X[,2])
plot(X2, f_coverage2, ylim=c(0, 1), type="l", lty=1, xlab="x", ylab="coverage",mgp=c(1.8,0.6,0), main="f2")
f = f2(X2)
f = (f - min(f))/diff(range(f))
lines(X2, f, lty=2)
abline(h=1-alpha, lty=3, col="red")

X3 = sort(X[,3])
plot(X3, f_coverage3, ylim=c(0, 1), type="l", lty=1, xlab="x", ylab="coverage",mgp=c(1.8,0.6,0), main="f3")
f = f3(X3)
f = (f - min(f))/diff(range(f))
lines(X3, f, lty=2)
abline(h=1-alpha, lty=3, col="red")

X4 = sort(X[,4])
plot(X4, f_coverage4, ylim=c(0, 1), type="l", lty=1, xlab="x", ylab="coverage",mgp=c(1.8,0.6,0), main="f4")
f = f4(X4)
f = (f - min(f))/diff(range(f))
lines(X4, f, lty=2)
abline(h=1-alpha, lty=3, col="red")

pl2 = recordPlot()
pdf("/Users/qigao/Documents/research/nonparamatric_additive_model/sim/sim_sd08_k8.pdf",height=6.5,width=8)
replayPlot(pl2)
dev.off()

var_samples <- sapply(samples, function(x) {x[[2]]})
hist(sqrt(var_samples), freq=F, xlab="sigma", main=NULL, mgp=c(1.8,0.5,0))
pl2 = recordPlot()
pdf("/Users/qigao/Documents/research/nonparamatric_additive_model/sim/hist_sigma.pdf",height=6, width=6.5)
replayPlot(pl2)
dev.off()

beta_samples <- sapply(samples, function(x) {x[[3]]})
plot_ci(X, beta_samples)
pl2 = recordPlot()
pdf("/Users/qigao/Documents/research/nonparamatric_additive_model/sim/f4_conf.pdf",height=6, width=6.5)
replayPlot(pl2)
dev.off()
